=== added directory 'data'
=== added file 'data/Sensors.conf'
--- data/Sensors.conf	1970-01-01 00:00:00 +0000
+++ data/Sensors.conf	2014-01-08 17:17:24 +0000
@@ -0,0 +1,3 @@
+[Default]
+QAccelerometer = core.accelerometer
+QOrientationSensor = core.orientationsensor

=== removed directory 'feedback'
=== removed file 'feedback/feedback.json'
--- feedback/feedback.json	2013-10-24 22:03:14 +0000
+++ feedback/feedback.json	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-{ "Interfaces": [ "QFeedbackHapticsInterface", "QFeedbackFileInterface", "QFeedbackThemeInterface" ] }

=== removed file 'feedback/feedback.pro'
--- feedback/feedback.pro	2013-10-24 22:03:14 +0000
+++ feedback/feedback.pro	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-include(../coverage.pri)
-include(../qtubuntu-sensors.pro)
-
-TEMPLATE = lib
-CONFIG += plugin
-TARGET = $$qtLibraryTarget(qtfeedback_ubuntu)
-PLUGIN_TYPE = feedback
-
-QT = core feedback
-
-HEADERS += qfeedback.h
-SOURCES += qfeedback.cpp
-
-target.path += $$[QT_INSTALL_PLUGINS]/feedback
-INSTALLS += target
-
-OTHER_FILES += feedback.json
-
-QMAKE_RPATHDIR = $$[QT_INSTALL_LIBS]/qtubuntu-feedback

=== removed file 'feedback/qfeedback.cpp'
--- feedback/qfeedback.cpp	2013-10-24 22:03:14 +0000
+++ feedback/qfeedback.cpp	1970-01-01 00:00:00 +0000
@@ -1,205 +0,0 @@
-/*
- * Copyright 2013 Canonical Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Author: Christian Dywan <christian.dywan@canonical.com>
- */
-
-#include <qfeedbackactuator.h>
-#include "qfeedback.h"
-#include <QtCore/QtPlugin>
-#include <QtCore/QDebug>
-#include <QtCore/QStringList>
-#include <QtCore/QCoreApplication>
-#include <QtCore/QFile>
-#include <QtCore/QVariant>
-#include <QtCore/QTimer>
-#include <QtCore/QProcess>
-#include <QtCore/QFileInfo>
-
-QFeedbackMir::QFeedbackMir() : QObject(qApp),
-    QFeedbackThemeInterface()
-{
-    const int nbDev = 1;
-    for (int i = 0; i < nbDev; ++i) {
-        actuatorList << createFeedbackActuator(this, i);
-    }
-}
-
-QFeedbackMir::~QFeedbackMir()
-{
-}
-
-QFeedbackInterface::PluginPriority QFeedbackMir::pluginPriority()
-{
-    return PluginNormalPriority;
-}
-
-QList<QFeedbackActuator*> QFeedbackMir::actuators()
-{
-    return actuatorList;
-}
-
-void QFeedbackMir::setActuatorProperty(const QFeedbackActuator &, ActuatorProperty prop, const QVariant &)
-{
-    switch (prop)
-    {
-    case Enabled:
-        break;
-    default:
-        break;
-    }
-}
-
-QVariant QFeedbackMir::actuatorProperty(const QFeedbackActuator &actuator, ActuatorProperty prop)
-{
-    switch (prop)
-    {
-    case Name:
-        {
-            return QString::fromLocal8Bit("Command line vibrator");
-        }
-
-    case State:
-        {
-            QFeedbackActuator::State ret = QFeedbackActuator::Unknown;
-            if (actuator.isValid()) {
-                ret = QFeedbackActuator::Ready;
-            }
-
-            return ret;
-        }
-    case Enabled:
-        {
-            // no global vibration policy, always enabled
-            return true;
-        }
-    default:
-        return QVariant();
-    }
-}
-
-bool QFeedbackMir::isActuatorCapabilitySupported(const QFeedbackActuator &, QFeedbackActuator::Capability cap)
-{
-    switch(cap)
-    {
-    case QFeedbackActuator::Envelope:
-    case QFeedbackActuator::Period:
-        return true;
-    default:
-        return false;
-    }
-}
-
-void QFeedbackMir::updateEffectProperty(const QFeedbackHapticsEffect *effect, EffectProperty)
-{
-    if (effect->period() > 0) {
-        /* Not currently supported */
-        reportError(effect, QFeedbackEffect::UnknownError);
-    }
-}
-
-void QFeedbackMir::vibrateOnce(const QFeedbackEffect* effect)
-{
-    int effectiveDuration = effect->duration();
-    switch (effectiveDuration)
-    {
-        case QFeedbackEffect::Infinite:
-        case 0:
-            effectiveDuration = 150;
-    }
-
-    QString ifaceFilename("/sys/class/timed_output/vibrator/enable");
-    if (!QFileInfo(ifaceFilename).exists())
-    {
-        qWarning() << ifaceFilename << "not available on this system";
-        return;
-    }
-
-    // This is fire and forget, no support for on-going vibrations or errors
-    // Later this will be replaced with using a vibration service
-    QProcess vibrator;
-    vibrator.setStandardOutputFile(ifaceFilename);
-    // The process launches async
-    vibrator.start("echo", QStringList() << QString("%1").arg(effectiveDuration));
-}
-
-void QFeedbackMir::setEffectState(const QFeedbackHapticsEffect *effect, QFeedbackEffect::State state)
-{
-    switch (state)
-    {
-    case QFeedbackEffect::Stopped:
-        break;
-    case QFeedbackEffect::Paused:
-        break;
-    case QFeedbackEffect::Running:
-        vibrateOnce(effect);
-        break;
-    default:
-        break;
-    }
-}
-
-QFeedbackEffect::State QFeedbackMir::effectState(const QFeedbackHapticsEffect *)
-{
-    // We don't currently support on-going vibrations
-    // This can be added when moving to a vibration service
-    return QFeedbackEffect::Stopped;
-}
-
-void QFeedbackMir::setLoaded(QFeedbackFileEffect *effect, bool)
-{
-    // Not currently supported
-     reportError(effect, QFeedbackEffect::UnknownError);
-}
-
-void QFeedbackMir::setEffectState(QFeedbackFileEffect *effect, QFeedbackEffect::State state)
-{
-    switch (state)
-    {
-    case QFeedbackEffect::Stopped:
-        break;
-    case QFeedbackEffect::Paused:
-        break;
-    case QFeedbackEffect::Running:
-        break;
-    default:
-        reportError(effect, QFeedbackEffect::UnknownError);
-        break;
-    }
-}
-
-QFeedbackEffect::State QFeedbackMir::effectState(const QFeedbackFileEffect *)
-{
-    return QFeedbackEffect::Stopped;
-}
-
-int QFeedbackMir::effectDuration(const QFeedbackFileEffect *effect)
-{
-    return 0;
-}
-
-QStringList QFeedbackMir::supportedMimeTypes()
-{
-    // The MIME type was taken from the MeeGo feedback plugin
-    return QStringList() << QLatin1String("vibra/ivt");
-}
-
-bool QFeedbackMir::play(QFeedbackEffect::Effect)
-{
-    QFeedbackHapticsEffect themeEffect;
-    vibrateOnce(&themeEffect);
-    return true;
-}
-

=== removed file 'feedback/qfeedback.h'
--- feedback/qfeedback.h	2013-10-24 22:03:14 +0000
+++ feedback/qfeedback.h	1970-01-01 00:00:00 +0000
@@ -1,76 +0,0 @@
-/*
- * Copyright 2013 Canonical Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- *
- * Author: Christian Dywan <christian.dywan@canonical.com>
- */
-
-#ifndef QFEEDBACK_MIR_H
-#define QFEEDBACK_MIR_H
-
-#include <QtCore/QList>
-#include <QtCore/QVector>
-#include <QtCore/QHash>
-#include <QtCore/QObject>
-#include <QtCore/QMutex>
-#include <QtCore/QTimer>
-
-#include <qfeedbackplugininterfaces.h>
-
-QT_BEGIN_HEADER
-QT_USE_NAMESPACE
-
-class QFeedbackMir : public QObject, public QFeedbackHapticsInterface, public QFeedbackFileInterface, public QFeedbackThemeInterface
-{
-    Q_OBJECT
-    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QtFeedbackPlugin" FILE "feedback.json")
-
-    Q_INTERFACES(QFeedbackHapticsInterface)
-    Q_INTERFACES(QFeedbackFileInterface)
-    Q_INTERFACES(QFeedbackThemeInterface)
-
-public:
-    QFeedbackMir();
-    virtual ~QFeedbackMir();
-
-    virtual PluginPriority pluginPriority();
-    virtual QList<QFeedbackActuator*> actuators();
-
-    //for actuator handling
-    virtual void setActuatorProperty(const QFeedbackActuator &, ActuatorProperty, const QVariant &);
-    virtual QVariant actuatorProperty(const QFeedbackActuator &, ActuatorProperty);
-    virtual bool isActuatorCapabilitySupported(const QFeedbackActuator &, QFeedbackActuator::Capability);
-
-    virtual void updateEffectProperty(const QFeedbackHapticsEffect *, EffectProperty);
-    virtual void setEffectState(const QFeedbackHapticsEffect *, QFeedbackEffect::State);
-    virtual QFeedbackEffect::State effectState(const QFeedbackHapticsEffect *);
-
-    //for loading files
-    virtual void setLoaded(QFeedbackFileEffect*, bool);
-    virtual void setEffectState(QFeedbackFileEffect *, QFeedbackEffect::State);
-    virtual QFeedbackEffect::State effectState(const QFeedbackFileEffect *);
-    virtual int effectDuration(const QFeedbackFileEffect *);
-    virtual QStringList supportedMimeTypes();
-
-    // theming
-    virtual bool play(QFeedbackEffect::Effect);
-private:
-    QList<QFeedbackActuator*> actuatorList;
-
-    void vibrateOnce(const QFeedbackEffect* effect);
-};
-
-QT_END_HEADER
-
-#endif // QFEEDBACK_MIR_H

=== removed directory 'lib'
=== removed file 'lib/accelerometersensor.cpp'
--- lib/accelerometersensor.cpp	2013-06-05 02:01:58 +0000
+++ lib/accelerometersensor.cpp	1970-01-01 00:00:00 +0000
@@ -1,24 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "accelerometersensor.h"
-#include "accelerometersensor_p.h"
-
-IMPLEMENT_READING(AccelerometerSensorReading);
-
-char const * const AccelerometerSensor::type("AccelerometerSensor");
-
-#include "moc_accelerometersensor.cpp"

=== removed file 'lib/accelerometersensor.h'
--- lib/accelerometersensor.h	2013-06-05 02:01:58 +0000
+++ lib/accelerometersensor.h	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ACCELEROMETERSENSOR_H
-#define ACCELEROMETERSENSOR_H
-
-#include <qsensor.h>
-#include <QAccelerometerReading>
-
-#include <QDebug>
-
-class AccelerometerSensorReadingPrivate;
-
-class Q_DECL_EXPORT AccelerometerSensorReading : public QSensorReading
-{
-    Q_OBJECT
-    DECLARE_READING(AccelerometerSensorReading)
-};
-
-class Q_DECL_EXPORT AccelerometerFilter : public QSensorFilter
-{
-public:
-    virtual bool filter(AccelerometerSensorReading *reading) = 0;
-
-private:
-    bool filter(QSensorReading *reading) { return filter(static_cast<AccelerometerSensorReading*>(reading)); }
-};
-
-class Q_DECL_EXPORT AccelerometerSensor : public QSensor
-{
-public:
-    explicit AccelerometerSensor(QObject *parent = NULL) : QSensor(AccelerometerSensor::type, parent) { qDebug() << __PRETTY_FUNCTION__ << endl; }
-    virtual ~AccelerometerSensor() {}
-
-    AccelerometerSensorReading *reading() const { return static_cast<AccelerometerSensorReading*>(QSensor::reading()); }
-    static char const * const type;
-};
-
-#endif

=== removed file 'lib/accelerometersensor_p.h'
--- lib/accelerometersensor_p.h	2013-06-05 02:01:58 +0000
+++ lib/accelerometersensor_p.h	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ACCELEROMETERSENSOR_P_H
-#define ACCELEROMETERSENSOR_P_H
-
-class AccelerometerSensorReadingPrivate
-{
-public:
-    AccelerometerSensorReadingPrivate()
-    {
-    }
-};
-
-#endif

=== removed file 'lib/lib.pro'
--- lib/lib.pro	2013-07-18 02:01:35 +0000
+++ lib/lib.pro	1970-01-01 00:00:00 +0000
@@ -1,16 +0,0 @@
-include(../coverage.pri)
-TEMPLATE = lib
-TARGET = qtubuntu_sensors
-
-QT = core sensors
-
-HEADERS += orientationsensor.h \
-    orientationsensor_p.h \
-    accelerometersensor.h \
-    accelerometersensor_p.h
-
-SOURCES += orientationsensor.cpp \
-    accelerometersensor.cpp
-
-target.path = $$[QT_INSTALL_LIBS]/qtubuntu-sensors
-INSTALLS += target

=== removed file 'lib/orientationsensor.cpp'
--- lib/orientationsensor.cpp	2013-06-05 02:01:58 +0000
+++ lib/orientationsensor.cpp	1970-01-01 00:00:00 +0000
@@ -1,24 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "orientationsensor.h"
-#include "orientationsensor_p.h"
-
-IMPLEMENT_READING(OrientationSensorReading);
-
-char const * const OrientationSensor::type("OrientationSensor");
-
-#include "moc_orientationsensor.cpp"

=== removed file 'lib/orientationsensor.h'
--- lib/orientationsensor.h	2013-06-05 02:01:58 +0000
+++ lib/orientationsensor.h	1970-01-01 00:00:00 +0000
@@ -1,53 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ORIENTATIONSENSOR_H
-#define ORIENTATIONSENSOR_H
-
-#include <qsensor.h>
-#include <QOrientationReading>
-
-#include <QDebug>
-
-class OrientationSensorReadingPrivate;
-
-class Q_DECL_EXPORT OrientationSensorReading : public QSensorReading
-{
-    Q_OBJECT
-    DECLARE_READING(OrientationSensorReading)
-};
-
-class Q_DECL_EXPORT OrientationFilter : public QSensorFilter
-{
-public:
-    virtual bool filter(OrientationSensorReading *reading) = 0;
-
-private:
-    bool filter(QSensorReading *reading) { return filter(static_cast<OrientationSensorReading*>(reading)); }
-};
-
-class Q_DECL_EXPORT OrientationSensor : public QSensor
-{
-    Q_OBJECT
-public:
-    explicit OrientationSensor(QObject *parent = NULL) : QSensor(OrientationSensor::type, parent) { qDebug() << __PRETTY_FUNCTION__ << endl; }
-    virtual ~OrientationSensor() {}
-
-    OrientationSensorReading *reading() const { return static_cast<OrientationSensorReading*>(QSensor::reading()); }
-    static char const * const type;
-};
-
-#endif

=== removed file 'lib/orientationsensor_p.h'
--- lib/orientationsensor_p.h	2013-06-05 02:01:58 +0000
+++ lib/orientationsensor_p.h	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ORIENTATIONSENSOR_P_H
-#define ORIENTATIONSENSOR_P_H
-
-class OrientationSensorReadingPrivate
-{
-public:
-    OrientationSensorReadingPrivate()
-    {
-    }
-};
-
-#endif

=== removed directory 'plugin'
=== removed file 'plugin/accelerometersensorimpl.cpp'
--- plugin/accelerometersensorimpl.cpp	2013-06-05 02:01:58 +0000
+++ plugin/accelerometersensorimpl.cpp	1970-01-01 00:00:00 +0000
@@ -1,79 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "accelerometersensorimpl.h"
-
-#include <QDebug>
-
-char const * const AccelerometerSensorImpl::id("aal.accelerometer");
-
-AccelerometerSensorImpl::AccelerometerSensorImpl(QSensor *sensor)
-    : QSensorBackend(sensor)
-{
-    m_accelCommon = new AccelerometerCommon(this);
-
-    // Register the reading instance with the parent
-    setReading<QAccelerometerReading>(&m_reading);
-
-    const qreal minDelay = m_accelCommon->getMinDelay();
-    if (minDelay > -1)
-    {
-        // Min and max sensor sampling frequencies, in Hz
-        addDataRate(minDelay, minDelay * 10);
-    }
-    addOutputRange(m_accelCommon->getMinValue(),
-                   m_accelCommon->getMaxValue(),
-                   m_accelCommon->getResolution());
-
-    // Connect to the accelerometer's readingChanged signal
-    connect(m_accelCommon, SIGNAL(accelerometerReadingChanged()), this, SLOT(onAccelerometerReadingChanged()));
-
-    setDescription(QLatin1String("Accelerometer Sensor"));
-}
-
-AccelerometerSensorImpl::~AccelerometerSensorImpl()
-{
-    if (m_accelCommon != NULL) {
-        delete m_accelCommon;
-    }
-}
-
-void AccelerometerSensorImpl::start()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-    m_accelCommon->start();
-}
-
-void AccelerometerSensorImpl::stop()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-    m_accelCommon->stop();
-}
-
-void AccelerometerSensorImpl::onAccelerometerReadingChanged()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-
-    const QAccelerometerReading *reading = m_accelCommon->reading();
-    Q_ASSERT(reading != NULL);
-
-    // Capture the coordinates from the accelerometer device
-    m_reading.setX(reading->x());
-    m_reading.setY(reading->y());
-    m_reading.setZ(reading->z());
-
-    newReadingAvailable();
-}

=== removed file 'plugin/accelerometersensorimpl.h'
--- plugin/accelerometersensorimpl.h	2013-06-05 02:01:58 +0000
+++ plugin/accelerometersensorimpl.h	1970-01-01 00:00:00 +0000
@@ -1,48 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ACCELEROMETERIMPL_H
-#define ACCELEROMETERIMPL_H
-
-#include "common.h"
-
-#include <qsensorbackend.h>
-
-class AccelerometerSensorImpl : public QSensorBackend
-{
-    Q_OBJECT
-
-public:
-    static char const * const id;
-
-    AccelerometerSensorImpl(QSensor *sensor = NULL);
-    virtual ~AccelerometerSensorImpl();
-
-    void start();
-    void stop();
-
-Q_SIGNALS:
-    void readingChanged();
-
-public Q_SLOTS:
-    void onAccelerometerReadingChanged();
-
-private:
-    AccelerometerCommon *m_accelCommon;
-    QAccelerometerReading m_reading;
-};
-
-#endif

=== removed file 'plugin/common.cpp'
--- plugin/common.cpp	2013-06-05 02:01:58 +0000
+++ plugin/common.cpp	1970-01-01 00:00:00 +0000
@@ -1,118 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "common.h"
-
-#include <QDebug>
-
-AccelerometerCommon::AccelerometerCommon(QObject *parent)
-    : QObject(parent),
-      m_reading(new QAccelerometerReading),
-      m_minDelay(-1),
-      m_minValue(0.0),
-      m_maxValue(0.0),
-      m_resolution(0.0)
-{
-    m_accelerometer = ua_sensors_accelerometer_new();
-
-    ua_sensors_accelerometer_set_reading_cb(
-        m_accelerometer,
-        AccelerometerCommon::onAccelerometerReadingCb,
-        static_cast<void *>(this)
-        );
-    
-    // Get the minimum sensor reading delay
-    m_minDelay = static_cast<qreal>(ua_sensors_accelerometer_get_min_delay(m_accelerometer));
-    m_minValue = static_cast<qreal>(ua_sensors_accelerometer_get_min_value(m_accelerometer));
-    m_maxValue = static_cast<qreal>(ua_sensors_accelerometer_get_max_value(m_accelerometer));
-    m_resolution = static_cast<qreal>(ua_sensors_accelerometer_get_resolution(m_accelerometer));
-}
-
-AccelerometerCommon::~AccelerometerCommon()
-{
-    if (m_reading != NULL) {
-        delete m_reading;
-    }
-}
-
-void AccelerometerCommon::start()
-{
-    ua_sensors_accelerometer_enable(m_accelerometer);
-}
-
-void AccelerometerCommon::stop()
-{
-    ua_sensors_accelerometer_disable(m_accelerometer);
-}
-
-QAccelerometerReading *AccelerometerCommon::reading() const
-{
-    return m_reading;
-}
-
-qreal AccelerometerCommon::getMinDelay() const
-{
-    return m_minDelay;
-}
-
-qreal AccelerometerCommon::getMinValue() const
-{
-    return m_minValue;
-}
-
-qreal AccelerometerCommon::getMaxValue() const
-{
-    return m_maxValue;
-}
-
-qreal AccelerometerCommon::getResolution() const
-{
-    return m_resolution;
-}
-
-void AccelerometerCommon::onAccelerometerReadingCb(UASAccelerometerEvent *event, void *context)
-{
-    AccelerometerCommon *ac = static_cast<AccelerometerCommon *>(context);
-    if (ac != NULL)
-        ac->onAccelerometerReading(event);
-}
-
-void AccelerometerCommon::onAccelerometerReading(UASAccelerometerEvent *event)
-{
-    Q_ASSERT(event != NULL);
-
-    float accel_x = uas_accelerometer_event_get_acceleration_x(event);
-    float accel_y = uas_accelerometer_event_get_acceleration_y(event);
-    float accel_z = uas_accelerometer_event_get_acceleration_z(event);
-
-    // Check for duplicate values to avoid unnecessary signal emission
-    if (m_reading->x() == accel_x &&
-        m_reading->y() == accel_y &&
-        m_reading->z() == accel_z)
-    {
-        return;
-    }
-
-    // Capture the coordinates from the accelerometer device
-    m_reading->setX(accel_x);
-    m_reading->setY(accel_y);
-    m_reading->setZ(accel_z);
-
-    // Set the timestamp as set by the hybris layer
-    m_reading->setTimestamp(uas_accelerometer_event_get_timestamp(event));
-
-    Q_EMIT accelerometerReadingChanged();
-}

=== removed file 'plugin/common.h'
--- plugin/common.h	2013-06-05 02:01:58 +0000
+++ plugin/common.h	1970-01-01 00:00:00 +0000
@@ -1,60 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef COMMON_H
-#define COMMON_H
-
-#include <ubuntu/application/sensors/accelerometer.h>
-
-#include <QAccelerometerReading>
-#include <QObject>
-
-class AccelerometerCommon : public QObject
-{
-    Q_OBJECT
-
-public:
-    AccelerometerCommon(QObject *parent = NULL);
-    ~AccelerometerCommon();
-
-    void start();
-    void stop();
-
-    QAccelerometerReading *reading() const;
-
-    qreal getMinDelay() const;
-    qreal getMinValue() const;
-    qreal getMaxValue() const;
-    qreal getResolution() const;
-
-    static void onAccelerometerReadingCb(UASAccelerometerEvent *event, void *context);
-
-Q_SIGNALS:
-    void accelerometerReadingChanged();
-
-private:
-    UASensorsAccelerometer *m_accelerometer;
-    QAccelerometerReading *m_reading;
-    qreal m_minDelay;
-    qreal m_minValue;
-    qreal m_maxValue;
-    qreal m_resolution;
-
-    // Gets called by the Aal sensor wrapper when there is a new accelerometer reading
-    void onAccelerometerReading(UASAccelerometerEvent *event);
-};
-
-#endif

=== removed file 'plugin/main.cpp'
--- plugin/main.cpp	2013-06-05 02:01:58 +0000
+++ plugin/main.cpp	1970-01-01 00:00:00 +0000
@@ -1,57 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "orientationsensor.h"
-#include "orientationsensorimpl.h"
-#include "accelerometersensor.h"
-#include "accelerometersensorimpl.h"
-
-#include <qsensorplugin.h>
-#include <qsensorbackend.h>
-#include <qsensormanager.h>
-#include <QAccelerometer>
-#include <QOrientationSensor>
-
-#include <QDebug>
-
-class AalSensorPlugins : public QObject, public QSensorPluginInterface, public QSensorBackendFactory
-{
-    Q_OBJECT
-    Q_PLUGIN_METADATA(IID "com.qt-project.Qt.QSensorPluginInterface/1.0" FILE "plugin.json")
-    Q_INTERFACES(QSensorPluginInterface)
-
-public:
-    void registerSensors()
-    {
-        qDebug() << "Registered the AalSensorPlugin types" << endl;
-        QSensorManager::registerBackend(QOrientationSensor::type, OrientationSensorImpl::id, this);
-        QSensorManager::registerBackend(QAccelerometer::type, AccelerometerSensorImpl::id, this);
-    }
-
-    // Instantiate all sensor backends here:
-    QSensorBackend *createBackend(QSensor *sensor)
-    {
-        if (sensor->identifier() == OrientationSensorImpl::id)
-            return new OrientationSensorImpl(sensor);
-
-        if (sensor->identifier() == AccelerometerSensorImpl::id)
-            return new AccelerometerSensorImpl(sensor);
-
-        return NULL;
-    }
-};
-
-#include "main.moc"

=== removed file 'plugin/orientationsensorimpl.cpp'
--- plugin/orientationsensorimpl.cpp	2013-06-05 02:01:58 +0000
+++ plugin/orientationsensorimpl.cpp	1970-01-01 00:00:00 +0000
@@ -1,96 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#include "orientationsensorimpl.h"
-
-#include <QDebug>
-
-char const * const OrientationSensorImpl::id("aal.orientationsensor");
-
-const float OrientationSensorImpl::m_accelDelta = 7.35;
-
-OrientationSensorImpl::OrientationSensorImpl(QSensor *sensor)
-    : QSensorBackend(sensor)
-{
-    m_accelCommon = new AccelerometerCommon(this);
-
-    // Register the reading instance with the parent
-    setReading<QOrientationReading>(&m_reading);
-
-    const qreal minDelay = m_accelCommon->getMinDelay();
-    if (minDelay > -1)
-    {
-        // Min and max sensor sampling frequencies, in Hz
-        addDataRate(minDelay, minDelay * 10);
-    }
-    addOutputRange(m_accelCommon->getMinValue(),
-                   m_accelCommon->getMaxValue(),
-                   m_accelCommon->getResolution());
-
-    // Connect to the accelerometer's readingChanged signal
-    connect(m_accelCommon, SIGNAL(accelerometerReadingChanged()), this, SLOT(onAccelerometerReadingChanged()));
-
-    setDescription(QLatin1String("Orientation Sensor"));
-}
-
-OrientationSensorImpl::~OrientationSensorImpl()
-{
-    if (m_accelCommon != NULL) {
-        delete m_accelCommon;
-    }
-}
-
-void OrientationSensorImpl::start()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-    m_accelCommon->start();
-}
-
-void OrientationSensorImpl::stop()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-    m_accelCommon->stop();
-}
-
-void OrientationSensorImpl::onAccelerometerReadingChanged()
-{
-    Q_ASSERT(m_accelCommon != NULL);
-
-    const QAccelerometerReading *reading = m_accelCommon->reading();
-    Q_ASSERT(reading != NULL);
-
-    // Interpret the accelerometer data into a meaningful orientation
-    if (reading->y() > m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::TopUp);
-    else if (reading->y() < -m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::TopDown);
-    else if (reading->x() > m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::RightUp);
-    else if (reading->x() < -m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::LeftUp);
-    else if (reading->z() > m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::FaceUp);
-    else if (reading->z() < -m_accelDelta)
-        m_reading.setOrientation(QOrientationReading::FaceDown);
-
-    if (m_reading.orientation() != m_readingCache.orientation())
-    {
-        // Emit readingChanged signal only if orientation actually changes
-        newReadingAvailable();
-    }
-
-    m_readingCache.setOrientation(m_reading.orientation());
-}

=== removed file 'plugin/orientationsensorimpl.h'
--- plugin/orientationsensorimpl.h	2013-06-05 02:01:58 +0000
+++ plugin/orientationsensorimpl.h	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-/*
- * Copyright (C) 2013 Canonical, Ltd.
- *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU Lesser General Public License as published by
- * the Free Software Foundation; version 3.
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU Lesser General Public License for more details.
- *
- * You should have received a copy of the GNU Lesser General Public License
- * along with this program.  If not, see <http://www.gnu.org/licenses/>.
- */
-
-#ifndef ORIENTATIONSENSORIMPL_H
-#define ORIENTATIONSENSORIMPL_H
-
-#include "common.h"
-
-#include <qsensorbackend.h>
-#include <QOrientationReading>
-
-class OrientationSensorImpl : public QSensorBackend
-{
-    Q_OBJECT
-
-public:
-    static char const * const id;
-
-    OrientationSensorImpl(QSensor *sensor = NULL);
-    virtual ~OrientationSensorImpl();
-
-    void start();
-    void stop();
-
-Q_SIGNALS:
-    void readingChanged();
-
-public Q_SLOTS:
-    void onAccelerometerReadingChanged();
-
-private:
-    // The distance from the center, right or left, that will trigger an
-    // orientation change when the user rotates the target device.
-    static const float m_accelDelta;
-
-    AccelerometerCommon *m_accelCommon;
-    QOrientationReading m_reading;
-    QOrientationReading m_readingCache;
-};
-
-#endif

=== removed file 'plugin/plugin.json'
--- plugin/plugin.json	2013-06-05 02:01:58 +0000
+++ plugin/plugin.json	1970-01-01 00:00:00 +0000
@@ -1,1 +0,0 @@
-{}

=== removed file 'plugin/plugin.pro'
--- plugin/plugin.pro	2013-07-18 02:01:35 +0000
+++ plugin/plugin.pro	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-include(../coverage.pri)
-include(../qtubuntu-sensors.pro)
-
-TEMPLATE = lib
-CONFIG += plugin
-TARGET = $$qtLibraryTarget(qtubuntu_sensors_plugins)
-PLUGIN_TYPE = sensors
-
-QT = sensors core
-
-INCLUDEPATH += $$PWD/../lib
-
-LIBS += -L$$OUT_PWD/../lib -lqtubuntu_sensors
-LIBS += -lubuntu_application_api
-
-HEADERS += \
-    common.h \
-    orientationsensorimpl.h \
-    accelerometersensorimpl.h
-
-SOURCES += \
-    common.cpp \
-    orientationsensorimpl.cpp \
-    accelerometersensorimpl.cpp \
-    main.cpp
-
-target.path += $$[QT_INSTALL_PLUGINS]/sensors
-INSTALLS += target
-
-OTHER_FILES += plugin.json
-
-QMAKE_RPATHDIR = $$[QT_INSTALL_LIBS]/qtubuntu-sensors

=== added directory 'plugins'
=== added directory 'plugins/feedback'
=== added file 'plugins/feedback/core_feedback.cpp'
--- plugins/feedback/core_feedback.cpp	1970-01-01 00:00:00 +0000
+++ plugins/feedback/core_feedback.cpp	2014-01-08 17:17:24 +0000
@@ -0,0 +1,149 @@
+/*
+ * Copyright 2013 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Christian Dywan <christian.dywan@canonical.com>
+ */
+
+#include "core_feedback.h"
+
+#include <qfeedbackactuator.h>
+
+#include <QtCore/QtPlugin>
+#include <QtCore/QDebug>
+#include <QtCore/QStringList>
+#include <QtCore/QCoreApplication>
+#include <QtCore/QFile>
+#include <QtCore/QVariant>
+#include <QtCore/QTimer>
+#include <QtCore/QProcess>
+#include <QtCore/QFileInfo>
+
+namespace
+{
+struct Vibrator
+{
+    Vibrator()
+        : file("/sys/class/timed_output/vibrator/enable"),
+          out(&file)
+    {
+        file.open(QFile::WriteOnly | QFile::Text);
+    }
+
+    void operator()(int duration)
+    {
+        (out << duration).flush();
+    }
+
+    QFile file;
+    QTextStream out;
+} vibrator;
+}
+
+core::Feedback::Feedback() : QObject()
+{
+    actuatorList << createFeedbackActuator(this, 42);
+}
+
+QFeedbackInterface::PluginPriority core::Feedback::pluginPriority()
+{
+    return PluginHighPriority;
+}
+
+QList<QFeedbackActuator*> core::Feedback::actuators()
+{
+    return actuatorList;
+}
+
+void core::Feedback::setActuatorProperty(const QFeedbackActuator&, ActuatorProperty prop, const QVariant &)
+{
+    switch (prop)
+    {
+    case Enabled:
+        break;
+    default:
+        break;
+    }
+}
+
+QVariant core::Feedback::actuatorProperty(const QFeedbackActuator &actuator, ActuatorProperty prop)
+{
+    QVariant result;
+
+    switch (prop)
+    {
+    case Name: result = QString::fromLocal8Bit("FileBasedNonFinalSoonToBeDeprecatedVibrator"); break;
+    case State: result = actuator.isValid() ? QFeedbackActuator::Ready : QFeedbackActuator::Unknown; break;
+    case Enabled: result = true; break;
+    }
+
+    return result;
+}
+
+bool core::Feedback::isActuatorCapabilitySupported(const QFeedbackActuator &, QFeedbackActuator::Capability cap)
+{
+    bool result = false;
+
+    switch(cap)
+    {
+    case QFeedbackActuator::Envelope:
+    case QFeedbackActuator::Period: result = true; break;
+    }
+
+    return result;
+}
+
+void core::Feedback::updateEffectProperty(const QFeedbackHapticsEffect *effect, EffectProperty)
+{
+    if (effect->period() != -1) {
+        /* Not currently supported */
+        reportError(effect, QFeedbackEffect::UnknownError);
+    }
+}
+
+void core::Feedback::vibrateOnce(const QFeedbackEffect* effect)
+{
+    int effectiveDuration = effect->duration();
+    switch (effectiveDuration)
+    {
+        case QFeedbackEffect::Infinite:
+        case 0:
+            effectiveDuration = 150;
+    }
+
+    vibrator(effectiveDuration);
+}
+
+void core::Feedback::setEffectState(const QFeedbackHapticsEffect *effect, QFeedbackEffect::State state)
+{
+    switch (state)
+    {
+    case QFeedbackEffect::Stopped:
+        break;
+    case QFeedbackEffect::Paused:
+        break;
+    case QFeedbackEffect::Running:
+        vibrateOnce(effect);
+        break;
+    case QFeedbackEffect::Loading:
+        break;
+    }
+}
+
+QFeedbackEffect::State core::Feedback::effectState(const QFeedbackHapticsEffect *)
+{
+    // We don't currently support on-going vibrations
+    // This can be added when moving to a vibration service
+    return QFeedbackEffect::Stopped;
+}

=== added file 'plugins/feedback/core_feedback.h'
--- plugins/feedback/core_feedback.h	1970-01-01 00:00:00 +0000
+++ plugins/feedback/core_feedback.h	2014-01-08 17:17:24 +0000
@@ -0,0 +1,60 @@
+/*
+ * Copyright 2013 Canonical Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ * Author: Christian Dywan <christian.dywan@canonical.com>
+ */
+
+#ifndef CORE_FEEDBACK_H
+#define CORE_FEEDBACK_H
+
+#include <QtCore/QList>
+#include <QtCore/QObject>
+
+#include <qfeedbackplugininterfaces.h>
+
+namespace core
+{
+class Feedback : public QObject, public QFeedbackHapticsInterface
+{
+    Q_OBJECT
+    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QtFeedbackPlugin" FILE "feedback.json")
+
+    Q_INTERFACES(QFeedbackHapticsInterface)
+
+public:
+    Feedback();
+
+    // From QFeedbackHapticsInterface
+    virtual PluginPriority pluginPriority();
+
+    QList<QFeedbackActuator*> actuators();
+
+    QFeedbackEffect::State effectState(const QFeedbackHapticsEffect *);
+    void setEffectState (const QFeedbackHapticsEffect* effect, QFeedbackEffect::State state);
+
+    bool isActuatorCapabilitySupported(const QFeedbackActuator &, QFeedbackActuator::Capability);
+    void setActuatorProperty(const QFeedbackActuator &, ActuatorProperty, const QVariant &);
+    QVariant actuatorProperty(const QFeedbackActuator &, ActuatorProperty);
+
+    void updateEffectProperty(const QFeedbackHapticsEffect* effect, EffectProperty property);
+
+private:
+    QList<QFeedbackActuator*> actuatorList;
+
+    void vibrateOnce(const QFeedbackEffect* effect);
+};
+}
+
+#endif // CORE_FEEDBACK_H

=== added file 'plugins/feedback/feedback.json'
--- plugins/feedback/feedback.json	1970-01-01 00:00:00 +0000
+++ plugins/feedback/feedback.json	2014-01-08 17:17:24 +0000
@@ -0,0 +1,1 @@
+{ "Interfaces": ["QFeedbackHapticsInterface"] }

=== added file 'plugins/feedback/feedback.pro'
--- plugins/feedback/feedback.pro	1970-01-01 00:00:00 +0000
+++ plugins/feedback/feedback.pro	2014-01-08 17:17:24 +0000
@@ -0,0 +1,18 @@
+include(../../coverage.pri)
+
+TEMPLATE = lib
+CONFIG += plugin
+TARGET = $$qtLibraryTarget(qtfeedback_ubuntu)
+PLUGIN_TYPE = feedback
+
+QT = core feedback
+
+HEADERS += core_feedback.h
+SOURCES += core_feedback.cpp
+
+target.path += $$[QT_INSTALL_PLUGINS]/feedback
+INSTALLS += target
+
+OTHER_FILES += feedback.json
+
+QMAKE_RPATHDIR = $$[QT_INSTALL_LIBS]/qtubuntu-feedback

=== added file 'plugins/plugins.pro'
--- plugins/plugins.pro	1970-01-01 00:00:00 +0000
+++ plugins/plugins.pro	2014-01-08 17:17:24 +0000
@@ -0,0 +1,5 @@
+TEMPLATE = subdirs
+
+SUBDIRS += \
+    feedback \
+    sensors 

=== added directory 'plugins/sensors'
=== added file 'plugins/sensors/core_accelerometer.cpp'
--- plugins/sensors/core_accelerometer.cpp	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_accelerometer.cpp	2014-01-08 17:17:24 +0000
@@ -0,0 +1,74 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "core_accelerometer.h"
+#include "core_shared_accelerometer.h"
+
+#include <QDebug>
+
+core::Accelerometer::Accelerometer(QSensor *sensor)
+    : QSensorBackend(sensor)
+{
+    // Register the reading instance with the parent
+    setReading<QAccelerometerReading>(&m_reading);
+
+    const qreal minDelay = core::SharedAccelerometer::instance().getMinDelay();
+    if (minDelay > -1)
+    {
+        // Min and max sensor sampling frequencies, in Hz
+        addDataRate(minDelay, minDelay * 10);
+    }
+    addOutputRange(core::SharedAccelerometer::instance().getMinValue(),
+                   core::SharedAccelerometer::instance().getMaxValue(),
+                   core::SharedAccelerometer::instance().getResolution());
+
+    // Connect to the accelerometer's readingChanged signal
+    // This has to be a queued connection as the sensor callback
+    // from the platform API can happen on an arbitrary thread.
+    connect(
+        &core::SharedAccelerometer::instance(),
+        SIGNAL(accelerometerReadingChanged(QSharedPointer<QAccelerometerReading>)), 
+        this, 
+        SLOT(onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading>)),
+        Qt::QueuedConnection);
+
+    setDescription(QLatin1String("Accelerometer Sensor"));
+}
+
+core::Accelerometer::~Accelerometer()
+{
+}
+
+void core::Accelerometer::start()
+{
+    core::SharedAccelerometer::instance().start();
+}
+
+void core::Accelerometer::stop()
+{
+    core::SharedAccelerometer::instance().stop();
+}
+
+void core::Accelerometer::onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading> reading)
+{
+    // Capture the coordinates from the accelerometer device
+    m_reading.setX(reading->x());
+    m_reading.setY(reading->y());
+    m_reading.setZ(reading->z());
+    m_reading.setTimestamp(reading->timestamp());
+
+    newReadingAvailable();
+}

=== added file 'plugins/sensors/core_accelerometer.h'
--- plugins/sensors/core_accelerometer.h	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_accelerometer.h	2014-01-08 17:17:24 +0000
@@ -0,0 +1,49 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef CORE_ACCELEROMETER_H
+#define CORE_ACCELEROMETER_H
+
+#include <QAccelerometerReading>
+
+#include <qsensorbackend.h>
+
+namespace core
+{
+class Accelerometer : public QSensorBackend
+{
+    Q_OBJECT
+public:
+    inline static const char* id()
+    {
+        return "core.accelerometer";
+    }
+
+    Accelerometer(QSensor *sensor);
+    virtual ~Accelerometer();
+
+    void start();
+    void stop();
+
+public Q_SLOTS:
+    void onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading> reading);
+
+private:
+    QAccelerometerReading m_reading;
+};
+}
+
+#endif // CORE_ACCELEROMETER_H

=== added file 'plugins/sensors/core_orientation_sensor.cpp'
--- plugins/sensors/core_orientation_sensor.cpp	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_orientation_sensor.cpp	2014-01-08 17:17:24 +0000
@@ -0,0 +1,84 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "core_orientation_sensor.h"
+
+#include "core_shared_accelerometer.h"
+
+#include <QDebug>
+
+const float core::OrientationSensor::m_accelDelta = 7.35;
+
+core::OrientationSensor::OrientationSensor(QSensor *sensor)
+    : QSensorBackend(sensor)
+{
+    // Register the reading instance with the parent
+    setReading<QOrientationReading>(&m_reading);
+
+    const qreal minDelay = core::SharedAccelerometer::instance().getMinDelay();
+    if (minDelay > -1)
+    {
+        // Min and max sensor sampling frequencies, in Hz
+        addDataRate(minDelay, minDelay * 10);
+    }
+    addOutputRange(core::SharedAccelerometer::instance().getMinValue(),
+                   core::SharedAccelerometer::instance().getMaxValue(),
+                   core::SharedAccelerometer::instance().getResolution());
+
+    // Connect to the accelerometer's readingChanged signal
+    connect(&core::SharedAccelerometer::instance(),
+            SIGNAL(accelerometerReadingChanged(QSharedPointer<QAccelerometerReading>)), 
+            this, 
+            SLOT(onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading>)),
+            Qt::QueuedConnection);
+
+    setDescription(QLatin1String("Orientation Sensor"));
+}
+
+void core::OrientationSensor::start()
+{
+    core::SharedAccelerometer::instance().start();
+}
+
+void core::OrientationSensor::stop()
+{
+    core::SharedAccelerometer::instance().stop();
+}
+
+void core::OrientationSensor::onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading> reading)
+{
+    // Interpret the accelerometer data into a meaningful orientation
+    if (reading->y() > m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::TopUp);
+    else if (reading->y() < -m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::TopDown);
+    else if (reading->x() > m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::RightUp);
+    else if (reading->x() < -m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::LeftUp);
+    else if (reading->z() > m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::FaceUp);
+    else if (reading->z() < -m_accelDelta)
+        m_reading.setOrientation(QOrientationReading::FaceDown);
+
+    if (m_reading.orientation() != m_readingCache.orientation())
+    {
+        // Emit readingChanged signal only if orientation actually changes
+        newReadingAvailable();
+    }
+
+    m_readingCache.setOrientation(m_reading.orientation());
+}

=== added file 'plugins/sensors/core_orientation_sensor.h'
--- plugins/sensors/core_orientation_sensor.h	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_orientation_sensor.h	2014-01-08 17:17:24 +0000
@@ -0,0 +1,59 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef CORE_ORIENTATION_SENSOR_H
+#define CORE_ORIENTATION_SENSOR_H
+
+#include <QAccelerometerReading>
+#include <QOrientationReading>
+
+#include <qsensorbackend.h>
+
+namespace core
+{
+class OrientationSensor : public QSensorBackend
+{
+    Q_OBJECT
+
+public:
+    inline static const char* id()
+    {
+        return "core.orientation";
+    }
+
+    OrientationSensor(QSensor *sensor);
+
+    // From QSensorBackend
+    void start();
+    void stop();
+
+Q_SIGNALS:
+    void readingChanged();
+
+public Q_SLOTS:
+    void onAccelerometerReadingChanged(QSharedPointer<QAccelerometerReading> reading);
+
+private:
+    // The distance from the center, right or left, that will trigger an
+    // orientation change when the user rotates the target device.
+    static const float m_accelDelta;
+
+    QOrientationReading m_reading;
+    QOrientationReading m_readingCache;
+};
+}
+
+#endif // CORE_ORIENTATION_SENSOR_H

=== added file 'plugins/sensors/core_sensor_plugins.cpp'
--- plugins/sensors/core_sensor_plugins.cpp	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_sensor_plugins.cpp	2014-01-08 17:17:24 +0000
@@ -0,0 +1,50 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "core_accelerometer.h"
+#include "core_orientation_sensor.h"
+#include "core_sensor_plugins.h"
+
+#include <qsensorplugin.h>
+#include <qsensorbackend.h>
+#include <qsensormanager.h>
+#include <QAccelerometer>
+#include <QOrientationSensor>
+
+void core::SensorPlugins::registerSensors()
+{
+    QSensorManager::registerBackend(
+                QOrientationSensor::type,
+                core::OrientationSensor::id(),
+                this);
+
+    QSensorManager::registerBackend(
+                QAccelerometer::type,
+                core::Accelerometer::id(),
+                this);
+}
+
+// Instantiate all sensor backends here:
+QSensorBackend* core::SensorPlugins::createBackend(QSensor *sensor)
+{
+    if (sensor->identifier() == core::OrientationSensor::id())
+        return new core::OrientationSensor(sensor);
+
+    if (sensor->identifier() == core::Accelerometer::id())
+        return new core::Accelerometer(sensor);
+
+    return NULL;
+}

=== added file 'plugins/sensors/core_sensor_plugins.h'
--- plugins/sensors/core_sensor_plugins.h	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_sensor_plugins.h	2014-01-08 17:17:24 +0000
@@ -0,0 +1,48 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef CORE_SENSOR_PLUGINS_H
+#define CORE_SENSOR_PLUGINS_H
+
+#include <qsensorplugin.h>
+#include <qsensorbackend.h>
+#include <qsensormanager.h>
+#include <QAccelerometer>
+#include <QOrientationSensor>
+
+#include <QDebug>
+
+namespace core
+{
+class SensorPlugins
+        : public QObject,
+          public QSensorPluginInterface,
+          public QSensorBackendFactory
+{
+    Q_OBJECT
+    Q_PLUGIN_METADATA(IID "com.qt-project.Qt.QSensorPluginInterface/1.0" FILE "sensors.json")
+    Q_INTERFACES(QSensorPluginInterface)
+
+public:
+    // From QSensorPluginInterface
+    void registerSensors();
+
+    // From QSensorBackendFactory
+    QSensorBackend *createBackend(QSensor *sensor);
+};
+}
+
+#endif // CORE_SENSOR_PLUGINS_H

=== added file 'plugins/sensors/core_shared_accelerometer.cpp'
--- plugins/sensors/core_shared_accelerometer.cpp	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_shared_accelerometer.cpp	2014-01-08 17:17:24 +0000
@@ -0,0 +1,102 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include "core_shared_accelerometer.h"
+
+#include <QDebug>
+#include <QMetaType>
+
+core::SharedAccelerometer& core::SharedAccelerometer::instance()
+{
+    static core::SharedAccelerometer instance;
+    return instance;
+}
+
+core::SharedAccelerometer::SharedAccelerometer(QObject *parent)
+    : QObject(parent),
+      m_minDelay(-1),
+      m_minValue(0.0),
+      m_maxValue(0.0),
+      m_resolution(0.0)
+{
+    qRegisterMetaType<QSharedPointer<QAccelerometerReading> >("QSharedPointer<QAccelerometerReading>");
+    m_accelerometer = ua_sensors_accelerometer_new();
+
+    ua_sensors_accelerometer_set_reading_cb(
+                m_accelerometer,
+                core::SharedAccelerometer::onAccelerometerReadingCb,
+                static_cast<void *>(this));
+
+    // Get the minimum sensor reading delay
+    m_minDelay = static_cast<qreal>(ua_sensors_accelerometer_get_min_delay(m_accelerometer));
+    m_minValue = static_cast<qreal>(ua_sensors_accelerometer_get_min_value(m_accelerometer));
+    m_maxValue = static_cast<qreal>(ua_sensors_accelerometer_get_max_value(m_accelerometer));
+    m_resolution = static_cast<qreal>(ua_sensors_accelerometer_get_resolution(m_accelerometer));
+}
+
+void core::SharedAccelerometer::start()
+{
+    ua_sensors_accelerometer_enable(m_accelerometer);
+}
+
+void core::SharedAccelerometer::stop()
+{
+    ua_sensors_accelerometer_disable(m_accelerometer);
+}
+
+qreal core::SharedAccelerometer::getMinDelay() const
+{
+    return m_minDelay;
+}
+
+qreal core::SharedAccelerometer::getMinValue() const
+{
+    return m_minValue;
+}
+
+qreal core::SharedAccelerometer::getMaxValue() const
+{
+    return m_maxValue;
+}
+
+qreal core::SharedAccelerometer::getResolution() const
+{
+    return m_resolution;
+}
+
+void core::SharedAccelerometer::onAccelerometerReadingCb(UASAccelerometerEvent *event, void *context)
+{
+    SharedAccelerometer* ac = static_cast<SharedAccelerometer*>(context);
+    if (ac != NULL)
+        ac->onAccelerometerReading(event);
+}
+
+void core::SharedAccelerometer::onAccelerometerReading(UASAccelerometerEvent *event)
+{
+    Q_ASSERT(event != NULL);
+
+    // TODO(tvoss): We should rely on an object pool to recycle accelerometer reading
+    // instances here. We could use a custom deleter for the shared pointer to put
+    // instances that have been successfully delivered to slots back into the pool.
+    QSharedPointer<QAccelerometerReading> reading(new QAccelerometerReading());
+    reading->setX(uas_accelerometer_event_get_acceleration_x(event));
+    reading->setY(uas_accelerometer_event_get_acceleration_y(event));
+    reading->setZ(uas_accelerometer_event_get_acceleration_z(event));
+
+    reading->setTimestamp(uas_accelerometer_event_get_timestamp(event));
+
+    Q_EMIT accelerometerReadingChanged(reading);
+}

=== added file 'plugins/sensors/core_shared_accelerometer.h'
--- plugins/sensors/core_shared_accelerometer.h	1970-01-01 00:00:00 +0000
+++ plugins/sensors/core_shared_accelerometer.h	2014-01-08 17:17:24 +0000
@@ -0,0 +1,64 @@
+/*
+ * Copyright (C) 2013 Canonical, Ltd.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU Lesser General Public License as published by
+ * the Free Software Foundation; version 3.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef CORE_SHARED_ACCELEROMETER_H
+#define CORE_SHARED_ACCELEROMETER_H
+
+#include <ubuntu/application/sensors/accelerometer.h>
+
+#include <QAccelerometerReading>
+#include <QObject>
+#include <QSharedPointer>
+
+Q_DECLARE_METATYPE(QSharedPointer<QAccelerometerReading>)
+
+namespace core
+{
+class SharedAccelerometer : public QObject
+{
+    Q_OBJECT
+
+public:
+    static SharedAccelerometer& instance();
+
+    void start();
+    void stop();
+
+    qreal getMinDelay() const;
+    qreal getMinValue() const;
+    qreal getMaxValue() const;
+    qreal getResolution() const;
+
+Q_SIGNALS:
+    void accelerometerReadingChanged(QSharedPointer<QAccelerometerReading> reading);
+
+private:
+    SharedAccelerometer(QObject *parent = NULL);
+
+    UASensorsAccelerometer *m_accelerometer;
+
+    qreal m_minDelay;
+    qreal m_minValue;
+    qreal m_maxValue;
+    qreal m_resolution;
+
+    // Gets called by the underlying platform when there is a new accelerometer reading
+    static void onAccelerometerReadingCb(UASAccelerometerEvent *event, void *context);
+    void onAccelerometerReading(UASAccelerometerEvent *event);
+};
+}
+
+#endif // CORE_SHARED_ACCELEROMETER_H

=== added file 'plugins/sensors/sensors.json'
--- plugins/sensors/sensors.json	1970-01-01 00:00:00 +0000
+++ plugins/sensors/sensors.json	2014-01-08 17:17:24 +0000
@@ -0,0 +1,1 @@
+{}

=== added file 'plugins/sensors/sensors.pro'
--- plugins/sensors/sensors.pro	1970-01-01 00:00:00 +0000
+++ plugins/sensors/sensors.pro	2014-01-08 17:17:24 +0000
@@ -0,0 +1,32 @@
+include(../../coverage.pri)
+
+TEMPLATE = lib
+CONFIG += plugin
+TARGET = $$qtLibraryTarget(qtubuntu_sensors_plugins)
+PLUGIN_TYPE = sensors
+
+QT = sensors core
+
+INCLUDEPATH += $$PWD/
+
+LIBS += -L$$OUT_PWD/
+LIBS += -lubuntu_application_api
+
+HEADERS += \
+    core_accelerometer.h \
+    core_orientation_sensor.h \
+    core_sensor_plugins.h \
+    core_shared_accelerometer.h
+
+SOURCES += \
+    core_accelerometer.cpp \
+    core_orientation_sensor.cpp \
+    core_sensor_plugins.cpp \
+    core_shared_accelerometer.cpp
+
+target.path += $$[QT_INSTALL_PLUGINS]/sensors
+INSTALLS += target
+
+OTHER_FILES += sensors.json
+
+QMAKE_RPATHDIR = $$[QT_INSTALL_LIBS]/qtubuntu-sensors

=== modified file 'qtubuntu-sensors.pro'
--- qtubuntu-sensors.pro	2013-10-24 22:03:14 +0000
+++ qtubuntu-sensors.pro	2014-01-08 17:17:24 +0000
@@ -2,10 +2,4 @@
 
 TEMPLATE = subdirs
 
-SUBDIRS += \
-    feedback \
-    lib \
-    plugin
-
-plugin.depends = lib
-import.depends = lib
+SUBDIRS += plugins

